#include "downloader.h"

Downloader::Downloader(QObject *parent)
    : QObject(parent)
{
    // Инициализируем менеджер ...
    manager = new QNetworkAccessManager();
    // ... и подключаем сигнал о завершении получения данных к обработчику полученного ответа
    connect(manager, &QNetworkAccessManager::finished, this, &Downloader::onResult);
}

void Downloader::getData()
{
    QUrl url("http://www.mtbank.by/currxml.php"); // URL, к которому будем получать данные
    // Отправляемый запрос
    QNetworkRequest request;
    // Устанавлвиваем URL в запрос
    request.setUrl(url);
    // Выполняем запрос
    manager->get(request);
}

void Downloader::onResult(QNetworkReply *reply)
{
    // Если в процесе получения данных произошла ошибка
    if(reply->error())
    {
        // Сообщаем об этом и показываем информацию об ошибках
        qDebug() << "ERROR";
        qDebug() << reply->errorString();
    }
    else
    {
        // В противном случае создаём объект для работы с файлом
        QFile *file = new QFile("C:\\Users\\User\\Documents\\Qt\\DownloadHttp\\file.xml");
        // Создаём файл или открываем его на перезапись ...
        if(file->open(QFile::WriteOnly))
        {
            // ... и записываем всю информацию со страницы в файл
            file->write(reply->readAll());
            // закрываем файл
            file->close();
        qDebug() << "Downloading is completed";
        // Посылаем сигнал о завершении получения файла
        emit onReady();
        }
    }
}

