#ifndef DOWNLOADER_H
#define DOWNLOADER_H

#include <QObject>
#include <QNetworkAccessManager>
#include <QNetworkRequest>
#include <QNetworkReply>
#include <QFile>
#include <QUrl>
#include <QDebug>

class Downloader : public QObject
{
    Q_OBJECT
public:
    explicit Downloader(QObject *parent = nullptr);

signals:
    void onReady();

public slots:
    // Метод инициализации запроса на получение данных
    void getData();
    // Слот обработки ответа о полученных данных
    void onResult(QNetworkReply *reply);

private:
    // менеджер сетевого доступа
    QNetworkAccessManager *manager;
};

#endif // DOWNLOADER_H
