#include  <QtWidgets>
#include "widget.h"

Widget::Widget(QWidget *parent)
    : QWidget         (parent)
    , loadButton      (new QPushButton("Load"))
    , textEdit        (new QTextEdit)
    , vertialLayout(new QVBoxLayout)
{
    QFont font("Times New Roman", 12, QFont::Normal);
    textEdit->document()->setDefaultFont(font);
    vertialLayout->setContentsMargins(10, 10, 10, 10);
    vertialLayout->setSpacing(20);
    vertialLayout->addWidget(loadButton);
    vertialLayout->addWidget(textEdit);
    this->setLayout(vertialLayout);
    // Инициализируем Downloader
    downloader = new Downloader();

    // по нажатию кнопки запускаем получение данных по http
    connect(loadButton, &QPushButton::clicked, downloader, &Downloader::getData);
    // по окончанию получения данных считываем данные из файл
    connect(downloader, &Downloader::onReady, this, &Widget::readFile);

}

Widget::~Widget()
{
    delete loadButton;
    delete textEdit;
    delete vertialLayout;
    loadButton       = nullptr;
    textEdit         = nullptr;
    vertialLayout = nullptr;
}

void Widget::readFile()
{
    QFile file("C:\\Users\\User\\Documents\\Qt\\DownloadHttp\\file.xml");
    // Открваем файл, если это возможно
    if (!file.open(QIODevice::ReadOnly))
    // если открытие файла невозможно, выходим из слота
        return;
    // в противном случае считываем данные и устанавилваем их в textEdit
    textEdit->setPlainText(QLatin1String(file.readAll()));
}
